/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WebMail Notifier.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


if(!com) var com={};
if(!com.tobwithu) com.tobwithu={};
com.tobwithu.wmn = {
  dout:Components.utils.reportError,

  mailInfo:[],
  onClick: function(aEvent) {
    if (aEvent &&(aEvent.button == 2||(aEvent.button ==0&&aEvent.ctrlKey)))
      return;
    if(aEvent &&((aEvent.button == 0&&aEvent.shiftKey)||aEvent.button == 1)){
      this.onCheckNow();
      return;
    }
    if(!this.p_getBoolPref("autoHideNotification"))this.closeWindow("alert:alert","wmn_alert");
    var elm=document.getElementById("wmn-statusbar");
    var openAll=aEvent && (aEvent.button == 0&&(aEvent.altKey||aEvent.metaKey));
    if(!openAll&&elm.getAttribute("newMail")!="true"&&this.mailInfo.length>0){
    //if(this.mailInfo.length==1){
      this.nsIWebMailNotifier.openMail(this.mailInfo[0].ind,null);
      return;
    }
    this.nsIWebMailNotifier.openMails(openAll);
  },
  onCheckNow: function() {
    this.nsIWebMailNotifier.checkMails(false);
  },
  onEnabled: function() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    var branch = prefService.getBranch("extensions.wmn.");
    branch.setBoolPref("enabled",!branch.getBoolPref("enabled"));
  },
  onContextMenu: function() {
    document.getElementById("wmn-window").collapsed=!this.p_getBoolPref("menuWindow");
    var em=document.getElementById("wmn-sidebar");
    if(em)em.collapsed=!this.p_getBoolPref("menuSidebar");
  },
  onOpenWMN: function() {
    this.nsIWebMailNotifier.openWMN();
  },
  onHelp: function() {
    this.nsIWebMailNotifier.openInTab("http://webmailnotifier.mozdev.org/drupal/forum/8");
  },
  onPreferences: function() {
    this.nsIWebMailNotifier.openOptions();
  },

  p_getBoolPref: function(name){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    var branch = prefService.getBranch("extensions.wmn.");
    return branch.getBoolPref(name);
  },
  openMail: function(ind,aEvent,folder) {
    if (aEvent.button == 2||(aEvent.button ==0&&aEvent.ctrlKey))
      return;
    if((aEvent.button == 0&&aEvent.shiftKey)||aEvent.button == 1){
      this.nsIWebMailNotifier.checkMail(ind);
    }else this.nsIWebMailNotifier.openMail(ind,folder,aEvent.button == 0&&(aEvent.altKey||aEvent.metaKey));
  },
  setEnabled: function(enabled){
    var elm=document.getElementById("wmn-statusbar");
    if(elm){
      elm.setAttribute("enabled", enabled);
    }
    elm=document.getElementById("wmn-toolbar-button");
    if(elm){
      elm.setAttribute("enabled",enabled);
    }
    document.getElementById("wmn-context-menu-enabled").setAttribute("checked",enabled);
  },
  /***********************************************************
  WebMailListener implementation
  ***********************************************************/
  onStateChange: function(aIndex,aCount,aData){
    if(aIndex==this.nsIWebMailNotifier.MSG_INIT){
      if(this.nsIWebMailNotifier.multiSession&&this.initTabMenu
        &&this.p_getBoolPref("showTabMenu"))this.initTabMenu();
      this.setEnabled(aCount==1);
      this.initCount();
    }else if(aIndex==this.nsIWebMailNotifier.MSG_ENABLED){
      this.setEnabled(aCount==1);
      return;
    }else if(aIndex==this.nsIWebMailNotifier.MSG_SHOWICON){
      var elm=document.getElementById("wmn-statusbar");
      if(elm)elm.collapsed=aCount==0;
      return;
    }else if(aIndex==this.nsIWebMailNotifier.MSG_SHOWTBBTN){
      this.showToolbarButton();
      return;
    }else if(aIndex==this.nsIWebMailNotifier.MSG_RESET){//accounts change
      this.initCount();
    }else{
      var obj=this.nsIWebMailNotifier.getAccountInfo(aIndex);
      for(var i=0;i<this.mailInfo.length;i++){
        var o=this.mailInfo[i];
        if(o.id==obj.id&&o.user==obj.user){
          o.mailCount=aCount;
          o.mailData=aData;
          var menu=document.getElementById("mi"+o.ind);
          if(menu){
      //      menu.setAttribute("image",aCount>0?"chrome://wmn/content/mail-new.png":"");
            menu.setAttribute("style","font-weight:"+(aCount>0?"bold":"normal")+(aCount<0?";color:GrayText":""));
            if(aCount>=0){
              menu.setAttribute("class","menuitem-iconic bookmark-item");
              if(this.p_getBoolPref("menuShowData")){
                if(aData.desc)menu.setAttribute("description",aData.desc);
                else menu.removeAttribute("description");
              }
            }else{
              menu.removeAttribute("class");
              menu.removeAttribute("description");
            }
          }

          var elm=document.getElementById("wmn-bm"+o.ind);
          if(elm){
            elm.setAttribute("newMail", o.mailCount>0);
            if(o.mailCount>=0){
              var str=o.accName+(o.mailCount>=0&&aData.desc?" : "+aData.desc:"");
              var ar=o.mailData.folders;
              if(ar&&ar.length>0){
                for(var i=0;i<ar.length;i+=2){
                  str+="\n - "+ar[i]+" : "+ar[i+1]; 
                }
              }
              elm.setAttribute("tooltiptext", str);
            }
            elm.setAttribute("label",this.getToolbarText(o,com.tobwithu.wmn.p_getBoolPref("showToolbarText")));
          }
          break;
        }
      }
    }
    var total=com.tobwithu.tooltip.makeTooltip(this.nsIWebMailNotifier,document.getElementById("wmn-tooltip-text"),this.mailInfo);

    var elm=document.getElementById("wmn-statusbar");
    if(elm){
      elm.setAttribute("newMail", total>0);
      elm.setAttribute("label",total>0?total:"");
    }
    elm=document.getElementById("wmn-toolbar-button");
    if(elm){
      elm.setAttribute("newMail", total>0);
      elm.setAttribute("value",total>0?total:"");
    }
  },

  /**********************************************************/
  closeWindow: function(type,name){
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var enm = wm.getEnumerator(type);
    while(enm.hasMoreElements()){
      var win = enm.getNext();
      if(win.name==name){
        win.close();
        return;
      }
    }
  },
  initCount: function() {
    var menu=document.getElementById("wmn-context-menu");
    var sep=document.getElementById("wmn-menu-sep");

    for(var i = 0; i < this.mailInfo.length; i++){
      if(menu.firstChild==sep)break;
      menu.removeChild(menu.firstChild);
    }
    var n=this.nsIWebMailNotifier.getAccountsNumber();
    this.mailInfo=[];
    for(var i=0;i<n;i++){
      if(!this.nsIWebMailNotifier.isAccountEnabled(i))continue;
      var obj=this.nsIWebMailNotifier.getAccountInfo(i);
      this.mailInfo.push(obj);
    }
    for(var i=0;i<this.mailInfo.length;i++){
      var o=this.mailInfo[i];
      o.mailCount=0;
      if(!o.alias||o.alias.indexOf("hidden/")!=0){
        var mi = document.createElement("menuitem");
        mi.setAttribute("id","mi"+o.ind);
        mi.setAttribute("label",o.accName);
        mi.setAttribute("oncommand","com.tobwithu.wmn.openMail("+o.ind+",event)");
        mi.setAttribute("style","color:GrayText");
        mi.setAttribute("image",this.nsIWebMailNotifier.getIconURL(o.id,o.user));
        menu.insertBefore(mi,sep);
      }
    }
    this.initToolbar();
  },
  onLoad: function() {
    var em=document.getElementById("key_openSidebar_wmn");
    if(em){
      var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                  .getService(Components.interfaces.nsIPrefService);
      var prefBranch = prefService.getBranch("extensions.wmn.shortcut.sidebar.");
      em.setAttribute("key",prefBranch.getCharPref("key"));
      em.setAttribute("modifiers",prefBranch.getCharPref("modifiers"));
    }
    //em=document.getElementById("wmn-statusbar");
    //em=document.getElementById("wmn-toolbarbutton-text");
    //em.setAttribute("style","color:red;font-size:12px;background-color:blue");
    if(!com.tobwithu.wmn.p_getBoolPref("showStatusbarIcon")){
      var elm=document.getElementById("wmn-statusbar");
      if(elm)elm.collapsed=true;
    }
    try {
      com.tobwithu.wmn.nsIWebMailNotifier = Components.classes["@mozilla.org/WebMailNotifier;1"]
                                                  .getService().wrappedJSObject;
      com.tobwithu.wmn.nsIWebMailNotifier.addListener(com.tobwithu.wmn);
    } catch (e){
com.tobwithu.wmn.dout(e);
    }
    if(com.tobwithu.wmn.onLoadFF)com.tobwithu.wmn.onLoadFF();
    window.removeEventListener("load", com.tobwithu.wmn.onLoad, false);
  },

  onUnload: function() {
    if(com.tobwithu.wmn.nsIWebMailNotifier)com.tobwithu.wmn.nsIWebMailNotifier.removeListener(com.tobwithu.wmn);
  },
  
  initToolbar:function(){
    var tb=document.getElementById("wmn-toolbar");
    if(tb){
      var ar=tb.childNodes;
      for(var i=0;i<ar.length;i++){
        var id=ar[i].getAttribute("id");
        if(id.indexOf("wmn-bm")==0&&
          !this.nsIWebMailNotifier.isAccountEnabled(id.substring(6))){
          tb.removeChild(ar[i--]);          
        }
      }
      var tblist=[];
      var ar=document.getElementsByTagName("toolbar");
      for(var i=0;i<ar.length;i++){
        var list=ar[i].getAttribute("currentset").split(",");
        if(ar[i]==tb)tblist=list;
        for(var j=0;j<list.length;j++){
          if(list[j].indexOf("wmn-bm")==0){
            var em=document.getElementById(list[j]);
            if(em)em.parentNode.removeChild(em);
            var ti=this.createToolbarItem(list[j].substring(6));
            if(ti)ar[i].insertBefore(ti,ar[i].childNodes[j]);
          }
        }
      }
      
      for(var i=0;i<this.mailInfo.length;i++){
        var o=this.mailInfo[i];
        if(!o.alias||o.alias.indexOf("hidden/")!=0){
          var em=document.getElementById("wmn-bm"+o.ind);
          if(!em){
            var ti=this.createToolbarItem(o.ind);
            if(ti)tb.appendChild(ti);
          }else{
            if(em.parentNode==tb&&tblist.indexOf("wmn-bm"+o.ind)==-1){
              var ti=this.createToolbarItem(o.ind);
              if(ti)tb.insertBefore(ti,em);
              em.parentNode.removeChild(em);
            }
          }
        }
      }
    }  
  },
  createToolbarItem: function(ind){  
    if(!this.nsIWebMailNotifier.isAccountEnabled(ind))return null;  
    var o=this.nsIWebMailNotifier.getAccountInfo(ind);
    var tf=com.tobwithu.wmn.p_getBoolPref("showToolbarText");
    var ti = document.createElement("toolbarbutton");
    ti.setAttribute("id","wmn-bm"+o.ind);
    ti.setAttribute("class","bookmark-item wmn-bookmark-button");
    ti.setAttribute("label",this.getToolbarText(o,tf));
    ti.setAttribute("tooltiptext",o.accName);
    ti.setAttribute("image",this.nsIWebMailNotifier.getIconURL(o.id,o.user));
    ti.setAttribute("newMail","false");
    ti.setAttribute("onclick","com.tobwithu.wmn.openMail("+o.ind+",event)");
    ti.setAttribute("removable","true");
    return ti;
  },  
  initToolbarMenu:function(){
    document.getElementById("wmn-show-text").setAttribute("checked",com.tobwithu.wmn.p_getBoolPref("showToolbarText"));
  },
  toggleToolbarText:function(tf){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    var branch = prefService.getBranch("extensions.wmn.");
    branch.setBoolPref("showToolbarText",tf);
    for(var i=0;i<this.mailInfo.length;i++){
      var o=this.mailInfo[i];
      if(!o.alias||o.alias.indexOf("hidden/")!=0){
        var em=document.getElementById("wmn-bm"+o.ind);
        if(em){
          em.setAttribute("label",this.getToolbarText(o,tf));
        }
      }
    }
  },
  getToolbarText:function(o,showText){
    var desc=o.mailData&&o.mailData.desc?o.mailData.desc:null;
    if(showText)return o.mailCount>=0&&desc?desc+" "+o.accName:o.accName;
    else return o.mailCount>=0&&desc?desc:"";
  }
};

window.addEventListener("load", com.tobwithu.wmn.onLoad, false);
window.addEventListener("unload", com.tobwithu.wmn.onUnload, false);